library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity regfile is
 port (rs1,rs2,rd: in std_logic_vector(4 downto 0);
       rst, clk, regwrite: in std_logic;
       datow: in std_logic_vector(31 downto 0);
       a,b: out std_logic_vector(31 downto 0) );
 end regfile;
 
 architecture beh of regfile is
 type regtype is array( 0 to 31) of std_logic_vector(31 downto 0);
  signal rf: regtype;
  
  begin
  
  a <= rf(conv_integer(rs1));
  
  b <= rf(conv_integer(rs2));
  
  process(rst,clk)
   begin
    if rst = '1' then
       for i in 0 to 31 loop
         rf(i) <= (rf(i)'range => '0');
       end loop;
    elsif clk'event and clk='1' and regwrite = '1' 
         then rf(conv_integer(rd)) <= datow;
    end if;
  end process;
 end beh;
              
       
 
